program Billard10;

uses
  mSum,
  mTSpielfeld in 'mTSpielfeld.pas',
  mTFarbKugel in 'mTFarbKugel.pas',
  mTKugel in 'mTKugel.pas';


var
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  ersteKugel    : TKugel;
  zweiteKugel   : TFarbKugel;
  dasSpielfeld  : TSpielfeld;

begin
  // Initialisierung
  randomize;
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  ersteKugel    := TKugel.init(50,50,0.05,random(360));
  zweiteKugel   := TFarbKugel.init(250,75,0.03,random(360));
  dasSpielfeld  := TSpielfeld.init(10,10,760,510);

  // Aktionsteil
  ersteKugel.merkeSpielfeld(DasSpielfeld);
  zweiteKugel.merkeSpielfeld(DasSpielfeld);
  dasSpielfeld.zeichneDich;
  repeat
    ersteKugel.bewege;
    zweiteKugel.bewege;
  until dieMaus.istGedrueckt;


  // Aufrumen
  ersteKugel.gibFrei;
  zweiteKugel.gibFrei;
  dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  derBildschirm.gibFrei
end.
