UNIT mTFressKugel;

interface

uses      mSuM, mTKugel, mTSpielfeld;
// Uses-Klausel ggf. anpassen

type
     TFressKugel = CLASS (TKugel)

     // Attribute

     private

     kenntKugel1, kenntKugel2, kenntKugel3 : TKugel;

     // Methoden

     private

     procedure werdeDicker;
     procedure zeichneSmile;
     public

     constructor init(px:zahl; py:zahl; pRichtung:Zahl; pvelocity:Zahl; pfarbe: Integer; pSpielfeld: TSpielfeld; pKug1,pKug2,pKug3 : TKugel);   overload;

     procedure bewege; override;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition
//+---------------------------------------------------------------------


//-------- init (public) -----------------------------------------------
constructor TFressKugel.init(px:zahl; py:zahl ; prichtung:zahl; pvelocity:zahl; pfarbe:INTEGER;
            pSpielfeld: TSpielfeld; pKug1,pKug2,pKug3 : TKugel);
begin
 inherited init (px,py,prichtung,pvelocity,pfarbe,pSpielfeld);
 kenntKugel1 := pKug1;
 kenntKugel2 := pKug2;
 kenntKugel3 := pKug3;
end;

//-------- bewege (public) ---------------------------------------------
procedure TFressKugel.bewege;
begin
    If (Abs(kenntKugel1.hposition-self.hposition)<radius+10) and
       (Abs(kenntKugel1.vposition-self.vposition)<radius+10) and
       kenntKugel1.aktiv
       then
       begin  kenntKUgel1.schalteDichAb; self.werdeDicker; end;

    If (Abs(kenntKugel2.hposition-self.hposition)<radius+10) and
       (Abs(kenntKugel2.vposition-self.vposition)<radius+10) and
       kenntKugel2.aktiv
       then
       begin kenntKugel2.schalteDichAb;self.werdeDicker; end;

    If (Abs(kenntKugel3.hposition-self.hposition)<radius+10) and
       (Abs(kenntKugel3.vposition-self.vposition)<radius+10) and
       kenntKugel3.aktiv
       then
       begin kenntKugel3.schalteDichAb; self.werdeDicker; end;
    If KenntKugel1.aktiv or KenntKugel2.aktiv or KenntKugel3.aktiv
       then inherited bewege
       else begin self.schalteDichAb; self.zeichne;self.zeichneSmile; end;
end;

procedure TFressKugel.werdeDicker;
begin
  radius := radius+10;
end;


procedure TFressKugel.zeichneSmile;
begin
   hatStift.setzeFarbe(gelb);
   hatStift.dreheBis(90);
   hatStift.bewegeUm(15);
   hatStift.dreheBis(0);
   hatStift.setzeLinienbreite(3);
   hatStift.bewegeUm(-10);
   hatStift.runter;
   hatStift.zeichneKreis(7);
   hatStift.hoch;
   hatStift.bewegeUm(20);
   hatStift.runter;
   hatStift.zeichneKreis(7);
   hatStift.hoch;
   hatStift.bewegeUm(-10);
   hatStift.dreheUm(-90);
   hatStift.bewegeUm(15);
   hatStift.runter;
   hatStift.setzeLinienbreite(6);
   hatStift.bewegeUm(10);
   hatStift.hoch;
   hatStift.bewegeUm(10);
   hatStift.dreheUm(-90);
   hatStift.bewegeUm(15);
   hatStift.runter;
   hatStift.setzeLinienbreite(3);
   hatStift.bewegeUm(-30);
end;

end.
