UNIT mTSpielfeld;

interface

uses      mSuM;
// Uses-Klausel ggf. anpassen

type
   TSpielfeld = CLASS

     // Attribute
     private
        zLinks : Zahl;
        zOben : Zahl;
        zRechts : Zahl;
        zUnten : Zahl;
     protected
         hatStift : Buntstift;

     //Objektbeziehungen:
        // hatBuntstift : Buntstift;
        // kenntTKugel () of TKugel;

     // Methoden
     public
        constructor init(plinks, poben, prechts, punten : Zahl);
        procedure zeichneDich;
        function liesLinks : Zahl;
        function liesOben : Zahl;
        function liesRechts : Zahl;
        function liesUnten : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TSpielfeld: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TSpielfeld.init(plinks, poben, prechts, punten : Zahl);
begin
   hatStift := BuntStift.init;
   zLinks := pLinks;
   zOben  := pOben;
   zRechts := pRechts;
   zUnten  := pUnten
end;

//-------- zeichneDich (public) ----------------------------------------
procedure TSpielfeld.zeichneDich;
begin
   hatStift.hoch;
   hatStift.bewegeBis(zLinks,zOben);
   hatStift.zeichneRechteck(zRechts-zLinks,zUnten-zOben);
end;

//-------- liesLinks (public) ------------------------------------------
function TSpielfeld.liesLinks : Zahl;
begin
  liesLinks := zLinks;
end;

//-------- liesOben (public) -------------------------------------------
function TSpielfeld.liesOben : Zahl;
begin
  liesOben := zOben;
end;

//-------- liesRechts (public) -----------------------------------------
function TSpielfeld.liesRechts : Zahl;
begin
  liesRechts := zRechts;
end;

//-------- liesUnten (public) ------------------------------------------
function TSpielfeld.liesUnten : Zahl;
begin
  liesunten := zUnten;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TSpielfeld.gibFrei;
begin
   hatStift.gibFrei
end;

end.
