UNIT mTKugel;

interface

uses         mSuM,mTSpielfeld;
// Uses-Klausel ggf. anpassen

type
   TKugel = CLASS 

     // Attribute
     private
        hatBuntstift   : Buntstift;
        kenntSpielfeld : TSpielfeld;

        //zFarbNr :Integer;
     protected
         zGeschwindigkeit : zahl;
         zfarbnr          : Integer;
         zRichtung        : zahl;
     //Objektbeziehungen:
        // hatBuntstift : Buntstift;
        // kenntTSpielfeld : TSpielfeld;

     // Methoden
     private
        procedure Loesche;
        procedure setzeRichtung(pWinkel:Zahl);
        procedure Zeichne;
        function hPosition : Zahl;
        function vPosition : Zahl;
     public
        constructor init(px,py, pwinkel, pgeschwindigkeit:Zahl; pFarbNr:Integer);
        procedure Bewege; virtual;
        procedure lerneSpielfeldKennen(pSpielfeld: TSpielfeld);
        destructor gibFrei;
   end;

implementation

//+---------------------------------------------------------------------
//|         TKugel: Methodendefinition
//+---------------------------------------------------------------------

//-------- Loesche (private) -------------------------------------------
procedure TKugel.Loesche;
begin
  hatBuntstift.wechsle;
  self.Zeichne;
  hatBuntstift.wechsle;
//  hatBuntstift.normal
end;

//-------- setzeRichtung (private) -------------------------------------
procedure TKugel.setzeRichtung(pWinkel:Zahl);
begin
  hatBuntstift.dreheBis(pWinkel);
  zrichtung := pWinkel;
end;

//-------- Zeichne (private) -------------------------------------------
procedure TKugel.Zeichne;
begin
  hatBuntstift.zeichneKreis(10);
end;

//-------- hPosition (private) -----------------------------------------
function TKugel.hPosition : Zahl;
begin
  result:=hatBuntstift.hPosition
end;

function TKugel.vPosition : Zahl;
begin
  result:=hatBuntstift.vPosition
end;

//-------- init (public) -----------------------------------------------
constructor TKugel.init(px,py, pwinkel, pgeschwindigkeit:Zahl; pFarbNr: Integer);
begin
  zGeschwindigkeit := pGeschwindigkeit;
  hatBuntstift := Buntstift.init;       // Buntstift erzeugen
  hatBuntStift.setzeFarbe(pFarbNr);
  hatBuntstift.bewegeBis(px,py);
  hatBuntstift.dreheBis (pwinkel);
  zrichtung := pwinkel;
  zFarbNr:=pFarbNr;
  self.zeichne
end;

//-------- Bewege (public) ---------------------------------------------
procedure TKugel.Bewege;
begin
  self.loesche;
  hatBuntstift.runter;
  hatBuntstift.zeichneKreis(1);
  hatBuntstift.hoch;
  hatBuntstift.bewegeUm(zGeschwindigkeit);       // an die Geschwindigkeit des Rechners anpassen!
  if self.hPosition > kenntSpielfeld.liesrechts-12 then // am rechten Rand angekommen (Radius der Kugel bercksichtigen!)
     Begin
     self.setzeRichtung(180 - zrichtung);  // nach links
     zfarbNr:=(zfarbNr+1) mod 8;
     hatBuntstift.setzeFarbe(zfarbNr);
     End;
  if self.hPosition < kenntSpielfeld.lieslinks +12 then // am linken Rand angekommen  (Radius der Kugel bercksichtigen!)
     Begin
     self.setzeRichtung(180 - zrichtung);    // nach rechts
     zfarbNr:=(zfarbNr+1) mod 8;
     hatBuntstift.setzeFarbe(zfarbNr);
     End;
  if self.vPosition > kenntSpielfeld.liesunten-12 then // am rechten Rand angekommen (Radius der Kugel bercksichtigen!)
     Begin
     self.setzeRichtung(- zrichtung);  // nach links
     zfarbNr:=(zfarbNr+1) mod 8;
     hatBuntstift.setzeFarbe(zfarbNr);
     End;
  if self.vPosition < kenntSpielfeld.liesoben +12 then // am linken Rand angekommen  (Radius der Kugel bercksichtigen!)
     Begin
     self.setzeRichtung(- zrichtung);    // nach rechts
     zfarbNr:=(zfarbNr+1) mod 8;
     hatBuntstift.setzeFarbe(zfarbNr);
     End;
  self.Zeichne;
end;

//-------- lerneSpielfeldKennen (public) -------------------------------
procedure TKugel.lerneSpielfeldKennen(pSpielfeld: TSpielfeld);
begin
  kenntSpielfeld := pSpielfeld;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKugel.gibFrei;
begin
  hatBuntstift.gibFrei;             // Buntstift wieder freigeben
end;

end.
