program Billard7;

uses
  mSum,
  mTSpielfeld in 'mTSpielfeld.pas',
  mTKugel in 'mTKugel.pas',
  mTReibKugel in 'mTReibKugel.pas',
  mTRandkugel in 'mTRandkugel.pas';

var
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  ersteKugel    : TKugel;
  randKugel    : TRandKugel;
  reibKugel    : TReibKugel;
  dasSpielfeld  : TSpielfeld;

begin
  // Initialisierung
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  ersteKugel    := TKugel.init(50,50,0.1);
  randKugel    := TRandKugel.init(250,75,0.2);
  reibKugel    := TReibKugel.init(350,100,1);
  dasSpielfeld  := TSpielfeld.init(10,10,460,210);
  ersteKugel.merke(dasSpielfeld);
  randKugel.merke(dasSpielfeld);
  reibKugel.merke(dasSpielfeld);

  // Aktionsteil
  dasSpielfeld.zeichneDich;
  ersteKugel.zeichne;
  randKugel.zeichne;
  reibKugel.zeichne;
  repeat
    ersteKugel.bewege;
    randKugel.bewege;
    reibKugel.bewege;
  until dieMaus.istGedrueckt;


  // Aufrumen
  ersteKugel.gibFrei;
  randKugel.gibFrei;
  reibKugel.gibFrei;
  dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  derBildschirm.gibFrei
end.
