UNIT mTBox;

interface

uses     mSuM;
// Uses-Klausel ggf. anpassen

type
   TBox = CLASS

     // Attribute
     private
        hatStift : BuntStift;
        zFarbe : GanzeZahl;
        zLinks : Zahl;
        zOben : Zahl;
        zRechts : Zahl;
        zUnten : Zahl;

     //Objektbeziehungen:
        // kenntTKugel () of TKugel;

     // Methoden
     public
        constructor init(plinks,poben,prechts,punten:Zahl ;pfarbe:GanzeZahl);
        procedure zeichneDich;
        function liesLinks : Zahl;
        function liesOben : Zahl;
        function liesRechts : Zahl;
        function liesUnten : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TBox: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TBox.init(plinks,poben,prechts,punten:Zahl ;pfarbe:GanzeZahl);
begin
   hatStift := BuntStift.init;
   zLinks := pLinks;
   zOben  := pOben;
   zRechts := pRechts;
   zUnten  := pUnten;
   zFarbe := pFarbe;
   hatStift.setzeFarbe(zFarbe)
end;

//-------- zeichneDich (public) ----------------------------------------
procedure TBox.zeichneDich;
begin
   hatStift.hoch;
   hatStift.bewegeBis(zLinks,zOben);
   hatStift.zeichneRechteck(zRechts-zLinks,zUnten-zOben);
end;

//-------- liesLinks (public) ------------------------------------------
function TBox.liesLinks : Zahl;
begin
   result := zLinks
end;

//-------- liesOben (public) -------------------------------------------
function TBox.liesOben : Zahl;
begin
   result := zOben
end;

//-------- liesRechts (public) -----------------------------------------
function TBox.liesRechts : Zahl;
begin
   result := zRechts
end;

//-------- liesUnten (public) ------------------------------------------
function TBox.liesUnten : Zahl;
begin
   result := zUnten
end;

//-------- gibFrei (public) --------------------------------------------
destructor TBox.gibFrei;
begin
   hatStift.gibFrei
end;

end.
