program Billard10;

uses
  mSum,
  mTSpielfeld in '..\Stufe10\mTSpielfeld.pas',
  mTKugel in '..\Stufe10\mTKugel.pas';

mTFarbKugel;
var
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  ersteKugel    : TKugel;
  zweiteKugel   : TKugel;
  dasSpielfeld  : TSpielfeld;

begin
  // Initialisierung
  randomize;
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  ersteKugel    := TKugel.init(50,50,random*0.05,random(360));
  zweiteKugel   := TKugel.init(250,75,random*0.05,random(360));
  dasSpielfeld  := TSpielfeld.init(10,10,760,510);

  // Aktionsteil
  ersteKugel.merkeSpielfeld(DasSpielfeld);
  zweiteKugel.merkeSpielfeld(DasSpielfeld);
  dasSpielfeld.zeichneDich;
  repeat
    ersteKugel.bewege;
    zweiteKugel.bewege;
  until dieMaus.istGedrueckt;


  // Aufrumen
  ersteKugel.gibFrei;
  zweiteKugel.gibFrei;
  dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  derBildschirm.gibFrei
end.
