program Billard7;

uses
  mSum,
  mTSpielfeld in 'mTSpielfeld.pas',
  mTKugel in 'mTKugel.pas',
  mTReibKugel in 'mTReibKugel.pas',
  mTFarbkugel in 'mTFarbkugel.pas',
  mTPulsierkugel in 'mTPulsierkugel.pas';

var
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  ersteKugel    : TFarbKugel;
  zweiteKugel    : TPulsierKugel;
  reibKugel    : TReibKugel;
  dasSpielfeld  : TSpielfeld;

begin
  // Initialisierung
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  ersteKugel    := TFarbKugel.init(50,50,10,0.1);
  zweiteKugel    := TPulsierKugel.init(250,75,20,0.2);
  reibKugel    := TReibKugel.init(350,150,25,1);
  dasSpielfeld  := TSpielfeld.init(10,10,760,210);
  ersteKugel.kennt(dasSpielfeld);
  zweiteKugel.kennt(dasSpielfeld);
  reibKugel.kennt(dasSpielfeld);

  // Aktionsteil
  dasSpielfeld.zeichneDich;
  ersteKugel.zeichne;

  zweiteKugel.zeichne;
  reibKugel.zeichne;
  repeat
    ersteKugel.faerbe(gelb);
    ersteKugel.bewege;

    zweiteKugel.bewege;
    reibKugel.bewege;
  until dieMaus.istGedrueckt;


  // Aufrumen
  ersteKugel.gibFrei;
  zweiteKugel.gibFrei;
  reibKugel.gibFrei;
  dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  derBildschirm.gibFrei
end.
