UNIT mTSpielfeld;

interface

uses   mSuM;
// Uses-Klausel ggf. anpassen

type
   TSpielfeld = CLASS

     // Attribute
     PRIVATE
        meinStift : Stift;
        links : Zahl;
        oben : Zahl;
        rechts : Zahl;
        unten : Zahl;

     //Objektbeziehungen:
        // hatStift : Stift;
        // kenntTKugel () of TKugel;

     // Methoden
     PUBLIC
        constructor init(plinks, poben, prechts, punten : Zahl);
        procedure zeichneDich;
        function liesLinks : Zahl;
        function liesOben : Zahl;
        function liesRechts : Zahl;
        function liesUnten : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TSpielfeld: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init --------------------------------------------------------
constructor TSpielfeld.init(plinks, poben, prechts, punten : Zahl);
begin
   meinStift := Stift.init;
   links := pLinks;
   oben  := pOben;
   rechts := pRechts;
   unten  := pUnten
end;

//-------- zeichneDich -------------------------------------------------
procedure TSpielfeld.zeichneDich;
begin
   meinStift.hoch;
   meinStift.bewegeBis(links,oben);
   meinStift.zeichneRechteck(rechts-links,unten-oben);
end;

//-------- liesLinks ---------------------------------------------------
function TSpielfeld.liesLinks : Zahl;
begin
   result := links
end;

//-------- liesOben ----------------------------------------------------
function TSpielfeld.liesOben : Zahl;
begin
   result := oben
end;

//-------- liesRechts --------------------------------------------------
function TSpielfeld.liesRechts : Zahl;
begin
   result := rechts
end;

//-------- liesUnten ---------------------------------------------------
function TSpielfeld.liesUnten : Zahl;
begin
   result := unten
end;

//-------- gibFrei -----------------------------------------------------
destructor TSpielfeld.gibFrei;
begin
   meinStift.gibFrei
end;

end.
