program Billard23;

uses
  mSum,
  mTSpielfeld in 'mTSpielfeld.pas',
  mTKugel in 'mTKugel.pas',
  mTFressKugel in 'mTFressKugel.pas';

var
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  ersteKugel    : TKugel;
  zweiteKugel   : TKugel;
  dritteKugel   : TKugel;
  haiKugel      : TFressKugel;
  dasSpielfeld  : TSpielfeld;
  hRand         : Zahl;
  vRand         : Zahl;

begin
  // Initialisierung
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dasSpielfeld  := TSpielfeld.init(20,10,1000,500);
  Randomize;
  //hRand:=int(random*50);
  //vRand:=int(random*50);

  ersteKugel    := TKugel.init(20+random(800),10+random(400),random(180)+1,1.5,rot,dasSpielfeld);
  zweiteKugel   := TKugel.init(20+random(800),10+random(400),random(-180)+1,2.5,gruen,dasSpielfeld);
  dritteKugel   := TKugel.init(20+random(800),10+random(400),random(180)+91,2,magenta,dasSpielfeld);
  haiKugel      := TFressKugel.init(20+random(800),10+random(400),-45,4,schwarz,dasSpielfeld,ersteKugel,zweiteKugel,dritteKugel);

  // Aktionsteil
  dasSpielfeld.zeichneDich;


  repeat

    If ersteKugel.aktiv then ersteKugel.bewege;
    If zweiteKugel.aktiv then zweiteKugel.bewege;
    If dritteKugel.aktiv then dritteKugel.bewege;
    If haikugel.aktiv    then haikugel.bewege;

  until dieMaus.istGedrueckt;


  // Aufrumen
  ersteKugel.gibFrei;
  zweiteKugel.gibFrei;
  dritteKugel.gibFrei;
  haiKugel.gibFrei;
  //dritteKugel.gibFrei;
  dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  derBildschirm.gibFrei
end.
