program Billard_11;

uses
  mSum,
  mTSpielfeld in 'mTSpielfeld.pas',
  mTKugel in 'mTKugel.pas',
  mTBuntKugel in 'mTBuntKugel.pas',
  mTBuntReibKugel in 'mTBuntReibKugel.pas';

var
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  ersteKugel    : TKugel;
  zweiteKugel   : TBuntreibKugel;
  dritteKugel   : TBuntKugel;
  dasSpielfeld  : TSpielfeld;

begin
  // Initialisierung
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  ersteKugel    := TKugel.init(50,50,0.1);
  zweiteKugel    := TBuntreibkugel.init(250,75,0.3);
  dritteKugel   := TBuntKugel.init(100,100,0.2);
  dasSpielfeld  := TSpielfeld.init(10,10,460,210);

  // Aktionsteil
  ersteKugel.merkeSpielfeld (dasSpielfeld);
  zweiteKugel.merkeSpielfeld (dasSpielfeld);
  dritteKugel.merkeSpielfeld (dasSpielfeld);
  ersteKugel.setzeStartrichtung(-30);
  zweiteKugel.setzeStartrichtung(-45);
  dritteKugel.setzeStartrichtung(20);
  dasSpielfeld.zeichneDich;

  repeat
    ersteKugel.bewege  ;
    zweiteKugel.bewege ;
    dritteKugel.bewege ;
  until dieMaus.istGedrueckt;


  // Aufrumen
  ersteKugel.gibFrei;
  zweiteKugel.gibFrei;
  dritteKugel.gibFrei;
   dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  derBildschirm.gibFrei
end.
