program Billard_9;

uses
  mSum,
  mTSpielfeld in 'mTSpielfeld.pas',
  mTKugel in 'mTKugel.pas',
  mTBuntKugel in 'mTBuntKugel.pas';

var
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  ersteKugel    : TKugel;
  zweiteKugel   : TBuntKugel;
  dasSpielfeld  : TSpielfeld;

begin
  // Initialisierung
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  ersteKugel    := TKugel.init(50,50);
  zweiteKugel    := TBuntkugel.init(250,75);
  dasSpielfeld  := TSpielfeld.init(10,10,460,210);

  // Aktionsteil
  ersteKugel.merkeSpielfeld (dasSpielfeld);
  zweiteKugel.merkeSpielfeld (dasSpielfeld);
  ersteKugel.setzeStartrichtung(-30);
  zweiteKugel.setzeStartrichtung(-45);
  dasSpielfeld.zeichneDich;

  repeat
    ersteKugel.bewege;
    zweiteKugel.bewege;
  until dieMaus.istGedrueckt;


  // Aufrumen
  ersteKugel.gibFrei;
  zweiteKugel.gibFrei;
   dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  derBildschirm.gibFrei
end.
