UNIT mTSpielfeld;

interface

uses         mSuM;
// Uses-Klausel ggf. anpassen

type
   TSpielfeld = CLASS

     // Attribute
     private
        hatBuntstift : Buntstift;
        zLinks : Zahl;
        zOben : Zahl;
        zRechts : Zahl;
        zUnten : Zahl;

     //Objektbeziehungen:
        // hatBuntstift : Buntstift;
        // kenntTKugel () of TKugel;

     // Methoden
     public
        constructor init(plinks, poben, prechts, punten : Zahl);
        procedure zeichneDich;
        function lieslinks : zahl;
        function liesOben : zahl;
        function liesrechts : zahl;
        function liesUnten : zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TSpielfeld: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TSpielfeld.init(plinks, poben, prechts, punten : Zahl);
begin
   hatBuntstift := Buntstift.init;
   zLinks := pLinks;
   zOben  := pOben;
   zRechts := pRechts;
   zUnten  := pUnten
end;

//-------- zeichneDich (public) ----------------------------------------
procedure TSpielfeld.zeichneDich;
begin
   hatBuntstift.hoch;
   hatBuntstift.bewegeBis(zLinks,zOben);
   hatBuntstift.zeichneRechteck(zRechts-zLinks,zUnten-zOben);
end;

//-------- lieslinks (public) ------------------------------------------
function TSpielfeld.lieslinks : zahl;
begin
  result := zlinks;
end;

//-------- liesOben (public) -------------------------------------------
function TSpielfeld.liesOben : zahl;
begin
   result := zoben
end;

//-------- liesrechts (public) -----------------------------------------
function TSpielfeld.liesrechts : zahl;
begin
   result := zrechts
end;

//-------- liesUnten (public) ------------------------------------------
function TSpielfeld.liesUnten : zahl;
begin
   result := zunten
end;

//-------- gibFrei (public) --------------------------------------------
destructor TSpielfeld.gibFrei;
begin
   hatBuntstift.gibFrei
end;

end.
