program tennis;

uses
  mSum,
  mTSpielfeld in 'mTSpielfeld.pas',
  mTKugel in 'mTKugel.pas',
  mTBox in 'mTBox.pas';

var
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  ersteKugel    : TKugel;
  dasSpielfeld  : TSpielfeld;
  dieBox        : TBox; 

begin
  // Initialisierung
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dasSpielfeld  := TSpielfeld.init(10,10,500,210);
  dieBox        := TBox.init(50,100,100,130,rot);
  ersteKugel    := TKugel.init(50,50,10,0.2);
  ersteKugel.merkeSpielfeld(dasSpielfeld);
  ersteKugel.merkeBox(dieBox);

  // Aktionsteil
  dasSpielfeld.zeichneDich;
  dieBox.zeichneDich;
  repeat
    ersteKugel.bewege;
    dieBox.zeichneDich;
  until dieMaus.istGedrueckt or ersteKugel.inBox;
  

  // Aufrumen
  ersteKugel.gibFrei;
  dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  dieBox.gibFrei;
  derBildschirm.gibFrei
end.
