program tennis;

uses
  mSum,
  mTSpielfeld in 'mTSpielfeld.pas',
  mTKugel in 'mTKugel.pas',
  mTSchlaeger in 'mTSchlaeger.pas';

var
  derBildschirm : Bildschirm;
  dieMaus       : Maus;
  ersteKugel    : TKugel;
  dasSpielfeld  : TSpielfeld;
  derSchlaeger  : TSchlaeger;

begin
  // Initialisierung
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dasSpielfeld  := TSpielfeld.init(10,10,500,210);
  derSchlaeger  := TSchlaeger.init(150,50,400,150,rot);
  ersteKugel    := TKugel.init(50,50,10,0.2);
  ersteKugel.merkeSpielfeld(dasSpielfeld);
  ersteKugel.merkeSchlaeger(derSchlaeger);

  // Aktionsteil
  dasSpielfeld.zeichneDich;
  derSchlaeger.zeichneDich;
  repeat
    ersteKugel.bewege;
    //derSchlaeger.zeichneDich;
  until dieMaus.istGedrueckt;
  

  // Aufrumen
  ersteKugel.gibFrei;
  dieMaus.gibFrei;
  dasSpielfeld.gibFrei;
  derSchlaeger.gibFrei;
  derBildschirm.gibFrei
end.
