UNIT mTSchlaeger;

interface

uses       mSuM;
  const diff = 10;
// Uses-Klausel ggf. anpassen

type
   TSchlaeger = CLASS

     // Attribute
     private
        hatStift : BuntStift;
        zFarbe : GanzeZahl;
        zLinks : Zahl;
        zOben : Zahl;
        zRechts : Zahl;
        zUnten : Zahl;

     //Objektbeziehungen:
        // kenntTKugel () of TKugel;

     // Methoden
     public
        constructor init(plinks,poben,prechts,punten:Zahl;pfarbe:GanzeZahl);
        procedure hoch;
        procedure reagiereAuf(pZeichen : Zeichen);
        procedure runter;
        procedure zeichneDich;
        function liesLinks : Zahl;
        function liesOben : Zahl;
        function liesRechts : Zahl;
        function liesUnten : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TSchlaeger: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TSchlaeger.init(plinks,poben,prechts,punten:Zahl;pfarbe:GanzeZahl);
begin
   hatStift := BuntStift.init;
   zLinks := pLinks;
   zOben  := pOben;
   zRechts := pRechts;
   zUnten  := pUnten;
   zFarbe := pFarbe;
   hatStift.setzeFarbe(zFarbe)
end;

//-------- hoch (public) -----------------------------------------------
procedure TSchlaeger.hoch;
begin
  hatStift.radiere;
  zeichneDich;
  zOben := zOben -diff;
  zUnten:= zUnten -diff;
  hatStift.normal;
  zeichneDich
end;

//-------- reagiereAuf (public) ----------------------------------------
procedure TSchlaeger.reagiereAuf(pZeichen : Zeichen);
begin
  if (pZeichen = 'w') or (pZeichen = 'W') or (pZeichen='8')then hoch;
  if (pZeichen = 'y') or (pZeichen = 'Y') or (pZeichen='2')then runter
end;

//-------- runter (public) ---------------------------------------------
procedure TSchlaeger.runter;
begin
  hatStift.radiere;
  zeichneDich;
  zOben := zOben +diff;
  zUnten:= zUnten +diff;
  hatStift.normal;
  zeichneDich
end;

//-------- zeichneDich (public) ----------------------------------------
procedure TSchlaeger.zeichneDich;
begin
   hatStift.hoch;
   hatStift.bewegeBis(zLinks,zOben);
   hatStift.zeichneRechteck(zRechts-zLinks,zUnten-zOben);
end;

//-------- liesLinks (public) ------------------------------------------
function TSchlaeger.liesLinks : Zahl;
begin
   result := zLinks
end;

//-------- liesOben (public) -------------------------------------------
function TSchlaeger.liesOben : Zahl;
begin
   result := zOben
end;

//-------- liesRechts (public) -----------------------------------------
function TSchlaeger.liesRechts : Zahl;
begin
   result := zRechts
end;

//-------- liesUnten (public) ------------------------------------------
function TSchlaeger.liesUnten : Zahl;
begin
   result := zUnten
end;

//-------- gibFrei (public) --------------------------------------------
destructor TSchlaeger.gibFrei;
begin
   hatStift.gibFrei
end;

end.
